(
	-- CleanUp version from https://forum.cgpersia.com/f56/1-click-convert-3d-cad-211616/
	-- by kB@CGP
	-- thanks to TwoRock@CGP
	if abpmarkobj == undefined do
	(
		::ab_dimensionmark
		plugin simpleobject abpmarkobj
		name:"abpmarkobj"
		classid:#(0x5a7923e7, 0x3eeb24d6)
		invisible:true
		category:"abplugin" (
			local updateDimension
			local dirtyflag = true
			local oidmax,oidmin,oidmax02,oidmin02
			local viewporttype = viewport.gettype()
			local ltransform = if activeGrid == undefined then
			(
				case viewporttype of
				(
					default: Matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
					#view_top: Matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
					#view_bottom: Matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
					#view_front: Matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0]
					#view_back: Matrix3 [-1,0,0] [0,0,1] [0,1,0] [0,0,0]
					#view_right: Matrix3 [0,1,0] [0,0,1] [1,0,0] [0,0,0]
					#view_left: Matrix3 [0,-1,0] [0,0,1] [-1,0,0] [0,0,0]
					#view_camera: Matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
					#view_persp_user: Matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
					#view_iso_user: Matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
				)
			)
			else (activeGrid.transform)
			fn redrawdim globalupdate:#none thevalue:0 =
			(
				dirtyflag = true
				updateDimension()
			)
			parameters main rollout:params
			(
				node01 type:#node
				usrenablelocal type:#boolean default:false
				USRsize type:#worldUnits default:1
				USRArrowSize type:#worldUnits default:1 ui:spn_arrowsize
				usrfontsize type:#worldUnits default:1 ui:spn_fontsize
				on USRsize set val do redrawdim globalupdate:#USRsize thevalue:val
				on USRArrowSize set val do redrawdim globalupdate:#USRArrowSize thevalue:val
				on usrfontsize set val do redrawdim globalupdate:#USRArrowSize thevalue:val
				USRAccuracy type:#integer default:2 ui:spn_accuracy
				usrinvertdisplay type:#boolean default:false ui:chk_invertdisplay
				on USRAccuracy set val do redrawdim globalupdate:#USRAccuracy thevalue:val
				on usrinvertdisplay set val do redrawdim globalupdate:#usrinvertdisplay thevalue:val
				usrupdate type:#boolean default:false
				on usrupdate set val do redrawdim globalupdate:#usrupdate thevalue:val
				oidarrowsize type:#worldUnits default:100
			)
			rollout params "Parameters"
			(
				group "Dim size"
				(
					spinner spn_arrowsize "Arrow size:" height:16 range:[1,1000,100] type:#worldUnits align:#right offset:[3,0]
					spinner spn_fontsize "Font:" height:16 range:[1,1000,100] type:#worldUnits align:#right offset:[3,0]
					checkbutton ckb_lock "Lock" checked:true height:16 align:#left offset:[0, - 20]
				)
				group "Decimal"
				(
					spinner spn_accuracy "Rounding" height:16 range:[1,2,2] type:#integer align:#right offset:[3,0]
					checkbox chk_invertdisplay "Mirror position" align:#left offset:[0, - 2]
				)
				on params open do(spn_fontsize.enabled = not ckb_lock.checked)
				on ckb_lock changed state do(spn_fontsize.enabled = not state)
				on spn_arrowsize changed val do
				(
					if ckb_lock.checked do
					(
						spn_fontsize.value = (val - oidarrowsize) + spn_fontsize.value
					)
					oidarrowsize = val
				)
			)
			fn floattaketwodigits val =
			(
				local lval
				if USRAccuracy == 1 then
				(
					lval = (val * 10) as integer
					return (lval * 0.1)
				)
				if USRAccuracy == 2 then
				(
					lval = (val * 100) as integer
					return (lval * 0.00999993)
				)
			)
			fn getlocalborder obj islocal:usrenablelocal =
			(
				local lobj = obj
				if classof obj == line or classof obj == splineshape do
				(
					lobj = (snapShot obj)
				)
				if islocal do(ltransform = lobj.transform)
				local p1,p2,p3,p4
				local lborder = nodeGetBoundingBox lobj ltransform
				if isgrouphead node01 do
				(
					local temps = splineshape transform:ltransform
					addnewspline temps
					for i in node01.children do
					(
						if ((maxVersion())[1] / 1000 + 1998) == 2022 then
						(
							lnodeb02 = nodeGetBoundingBox i ltransform
							in coordsys ltransform
							(
								addknot temps 1 #corner #curve lnodeb02[1]
								addknot temps 1 #corner #curve lnodeb02[2]
							)
						)
						else
						(
							lnodeb02 = nodeLocalBoundingBox i
							addknot temps 1 #corner #curve lnodeb02[1]
							addknot temps 1 #corner #curve lnodeb02[2]
						)
					)
					lborder = nodeGetBoundingBox temps ltransform
					delete temps
				)
				in coordsys ltransform
				(
					lnodewidth = (lborder[2] - lborder[1]).x
					lnodelength = (lborder[2] - lborder[1]).y
					lnodeheight = (lborder[2] - lborder[1]).z
					p1 = lborder[1]
					p2 = (lborder[1] + [1,0,0] * lnodewidth)
					p3 = (p2 + [0,1,0] * lnodelength)
					p4 = lborder[2]
					if usrinvertdisplay then
					(
						p1 = (lborder[1] + [1,0,0] * lnodewidth)
						p2 = lborder[1]
						p3 = (lborder[1] + [0,1,0] * lnodelength)
						p4 = (lborder[2] - [1,0,0] * lnodewidth)
					)
				)
				p1 = (p1 * ltransform)
				p2 = (p2 * ltransform)
				p3 = (p3 * ltransform)
				p4 = (p4 * ltransform)
				if classof obj == line or classof obj == splineshape do(delete lobj)
				return #(p1,p2,p3,p4,ltransform[1],ltransform[2],ltransform[3])
			)
			fn updatedimension =
			(
				if node01 == undefined do(return undefined)
				local lnodeb = nodeGetBoundingBox node01 (Matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])
				local lnodeb02 = nodeLocalBoundingBox node01
				local lnewmax = lnodeb[1]
				local lnewmin = lnodeb[2]
				local lnewmax02 = lnodeb02[1]
				local lnewmin02 = lnodeb02[2]
				if (dirtyflag == true or oidmax != lnewmax or oidmin != lnewmin or oidmax02 != lnewmax02 or oidmin02 != lnewmin02) do
				(
					dirtyflag = false
					oidmax = lnewmax
					oidmin = lnewmin
					oidmax02 = lnewmax02
					oidmin02 = lnewmin02
					local vertarray = #()
					local facearray = #()
					local lpoass = #()
					local edgevis = #()
					local texts = #()
					local lnodepos = getlocalborder node01
					if usrinvertdisplay then
					(
						append lpoass #(lnodepos[1],lnodepos[2],1,0,lnodepos[5],lnodepos[6],lnodepos[7],0)
						append lpoass #(lnodepos[2],lnodepos[3],2,24,lnodepos[5],lnodepos[6],lnodepos[7],10)
						if distance lnodepos[3] lnodepos[4] > 0.01 then
						(
							append lpoass #(lnodepos[4],lnodepos[3],3,48,lnodepos[5],lnodepos[6],lnodepos[7],20)
						)
					)
					else
					(
						append lpoass #(lnodepos[2],lnodepos[1],1,0,lnodepos[5],lnodepos[6],lnodepos[7],0)
						append lpoass #(lnodepos[3],lnodepos[2],2,24,lnodepos[5],lnodepos[6],lnodepos[7],10)
						if distance lnodepos[3] lnodepos[4] > 0.01 then
						(
							append lpoass #(lnodepos[3],lnodepos[4],3,48,lnodepos[5],lnodepos[6],lnodepos[7],20)
						)
					)
					for lpoas in lpoass do
					(
						local lwidth = usrarrowsize * 0.05
						local llength = usrarrowsize * 1.2
						local lfontsize = usrfontsize
						local oldpos01 = lpoas[1]
						local oldpos02 = lpoas[2]
						local thex,they,thez
						thex = (normalize (oldpos02 - oldpos01))
						they = (normalize (cross lpoas[7] thex))
						thez = normalize (cross thex they)
						if lpoas[3] == 3 do
						(
							they = -(normalize (cross lpoas[6] - thex))
						)
						local thedistance = (distance oldpos01 oldpos02)
						local thetmx = if lpoas[3] != 3 then - thex else thex
						local thetmy = if true then - they else they
						local thetmz = thez
						if not usrenablelocal and lpoas[3] == 3 do
						(
							case viewporttype of
							(
								#view_right:
								(
									thetmx = -thetmx
									thetmz = -thetmz
								)
								#view_left:
								(
									thetmx = -thetmx
									thetmz = -thetmz
								)
							)
						)
						local ltxtpos = (oldpos01 + oldpos02) / 2 + they * llength * 0.7 + they * lfontsize
						local ltextnode = text transform:(Matrix3 thetmx thetmy thetmz ltxtpos) size:lfontsize steps:2 text:((floattaketwodigits thedistance) as string)
						append texts (snapShot ltextnode)
						delete ltextnode
						append vertarray (oldpos01 - thex * lwidth * 0.5 + they * (llength * 0.4))
						append vertarray (oldpos01 + thex * lwidth * 0.5 + they * (llength * 0.4))
						append vertarray (oldpos01 + thex * lwidth * 0.5 + they * llength)
						append vertarray (oldpos01 - thex * lwidth * 0.5 + they * llength)
						append vertarray (oldpos02 - thex * lwidth * 0.5 + they * (llength * 0.4))
						append vertarray (oldpos02 + thex * lwidth * 0.5 + they * (llength * 0.4))
						append vertarray (oldpos02 + thex * lwidth * 0.5 + they * llength)
						append vertarray (oldpos02 - thex * lwidth * 0.5 + they * llength)
						append vertarray (oldpos01 + thex * llength * 0.4 + they * (llength * 0.7 - lwidth / 2))
						append vertarray (oldpos01 + thex * llength * 0 + they * (llength * 0.7 + lwidth / 2))
						append vertarray (oldpos02 - thex * llength * 0.4 + they * (llength * 0.7 - lwidth / 2))
						append vertarray (oldpos02 - thex * llength * 0.4 + they * (llength * 0.7 + lwidth / 2))
						append vertarray (oldpos01 + thex * lwidth * 0 + they * (llength * 0.7))
						append vertarray (oldpos01 + thex * llength * 0.4 + they * (llength * 0.7 + lwidth * 1.3))
						append vertarray (oldpos01 + thex * llength * 0.4 + they * (llength * 0.7 - lwidth * 1.3))
						append vertarray (oldpos02 - thex * lwidth * 0.5 + they * (llength * 0.7))
						append vertarray (oldpos02 - thex * llength * 0.4 + they * (llength * 0.7 + lwidth * 1.3))
						append vertarray (oldpos02 - thex * llength * 0.4 + they * (llength * 0.7 - lwidth * 1.3) )
						append vertarray (oldpos01)
						append vertarray (oldpos01 - thex * lwidth * 0.5 + they * (llength * 0.4))
						append vertarray (oldpos01 + thex * lwidth * 0.5 + they * (llength * 0.4))
						append vertarray (oldpos02)
						append vertarray (oldpos02 - thex * lwidth * 0 + they * (llength * 0.4))
						append vertarray (oldpos02 + thex * lwidth * 0.5 + they * (llength * 0.4))
						append facearray [1 + lpoas[4],2 + lpoas[4],3 + lpoas[4]]
						append facearray [1 + lpoas[4],3 + lpoas[4],4 + lpoas[4]]
						append facearray [5 + lpoas[4],8 + lpoas[4],7 + lpoas[4]]
						append facearray [5 + lpoas[4],7 + lpoas[4],6 + lpoas[4]]
						append facearray [9 + lpoas[4],11 + lpoas[4],12 + lpoas[4]]
						append facearray [9 + lpoas[4],12 + lpoas[4],10 + lpoas[4]]
						append facearray [13 + lpoas[4],15 + lpoas[4],14 + lpoas[4]]
						append facearray [16 + lpoas[4],17 + lpoas[4],18 + lpoas[4]]
						append facearray [19 + lpoas[4],20 + lpoas[4],21 + lpoas[4]]
						append facearray [22 + lpoas[4],23 + lpoas[4],24 + lpoas[4]]
						append edgevis #(1 + lpoas[8],3)
						append edgevis #(1 + lpoas[8],1)
						append edgevis #(2 + lpoas[8],1)
						append edgevis #(3 + lpoas[8],3)
						append edgevis #(4 + lpoas[8],3)
						append edgevis #(4 + lpoas[8],1)
						append edgevis #(5 + lpoas[8],3)
						append edgevis #(6 + lpoas[8],1)
						append edgevis #(9 + lpoas[8],2)
						append edgevis #(10 + lpoas[8],2)
					)
					setmesh mesh vertices:vertarray faces:facearray
					for i in edgevis do(setedgevis mesh i[1] i[2] false)
					for t in texts do meshop.attach mesh t deletesourcenode:true
				)
			)
			on buildmesh do updatedimension()
		)
		rollout ab_dimensionmark "dimension mark"
		(
			local callbackupdateabpmarkitem,
			abmarkmaterial = (standard diffuse:white twosided:true selfillumamount:100)
			fn updateabpmark ev nd =
			(
				local obj = undefined
				for i in selection where isgrouphead i do(return undefined)
				for i in selection where i.parent != undefined and isgrouphead i.parent and getuserprop i.parent "abpmarkobj_" != undefined do
				(
					obj = i.parent
					exit
				)
				if obj == undefined do(return undefined)
				try (execute ((getuserprop obj "abpmarkobj_") + ".usrupdate=not " + (getuserprop obj "abpmarkobj_") + ".usrupdate")) catch ()
				redrawviews()
			)
			fn addcallback =
			(
				if ab_dimensionmark.callbackupdateabpmarkitem == undefined do
				(
					ab_dimensionmark.callbackupdateabpmarkitem = nodeeventcallback delay:1000 all:ab_dimensionmark.updateabpmark mouseup:true
				)
			)
			fn removecallback =
			(
				ab_dimensionmark.callbackupdateabpmarkitem = undefined
				gc light:true
			)
			fn startautomark myshapes asize fsize islocal facy:2 isinvert:false =
			(
				local oidselection = myshapes
				local objs = for grp in myshapes where grp.parent == undefined and findstring grp.name "abpmarkobj_" == undefined collect grp
				local biao = #()
				for obj in objs do
				(
					local oid_group = undefined
					try (oid_group = execute ((getuserprop obj "abpmarkobj_")as string)) catch ()
					if oid_group != undefined do
					(
						if oid_group.node01.name == obj.name do
						(
							if not isdeleted oid_group do (delete oid_group)
						)
					)
					local lname = (uniquename "abpmarkobj_" + (random 100000 300000) as string)
					setuserprop obj "abpmarkobj_" ("$" + lname)
					abpmark_obj = abpmarkobj wirecolor:black material:abmarkmaterial name:lname
					abpmark_obj.usrenablelocal = islocal
					abpmark_obj.node01 = obj
					abpmark_obj.usrarrowsize = asize
					abpmark_obj.oidarrowsize = asize
					abpmark_obj.usrfontsize = fsize
					abpmark_obj.usraccuracy = facy
					abpmark_obj.usrinvertdisplay = isinvert
					abpmark_obj.pivot.x = abpmark_obj.center.x
					abpmark_obj.pivot.y = abpmark_obj.center.y
					abpmark_obj.pivot.z = abpmark_obj.min.z
					append biao abpmark_obj
				)
				select biao
			)
		)
	)
	try(destroydialog ::geometrytoshape)catch()
	rollout geometrytoshape "3D for CAD" width:310 height:115 (
		local posX=10, posY=10, uiheight=22,
		iniFile = getDir #temp + "\\" + getFilenameFile(getThisScriptFilename()) + ".ini"
		label lbl1 "Projection plane:" pos:[posX,posY] width:140 height:16 align:#left
		checkbox chkx "x" pos:[posX+100,posY] width:34 height:16 checked:true align:#left
		checkbox chky "y" pos:[posX+140,posY] width:34 height:16 checked:true align:#left
		checkbox chkz "z" pos:[posX+180,posY] width:34 height:16 checked:true align:#left
		label lbl5 "2D line direction:" pos:[posX,posY+uiheight] width:150 height:24 align:#left visible:false
		checkbox chkxa "-x" pos:[posX+100,posY+uiheight] width:34 height:16 checked:false align:#left visible:false
		checkbox chkya "-y" pos:[posX+140,posY+uiheight] width:34 height:16 checked:false align:#left visible:false
		checkbox chkza "-z" pos:[posX+180,posY+uiheight] width:34 height:16 checked:false align:#left visible:false
		label lbl3 "Extract" pos:[posX,posY+uiheight] width:50 height:16 align:#left
		label lbl9 "Coordinate" pos:[posX,posY+uiheight] width:50 height:16 align:#left visible:false
		radiobuttons radtype "" pos:[posX+100,posY+uiheight] offsets:#([0,0],[-10,0],[0,0]) height:16 labels:#("original", "optimization", "outline") default:3 columns:3 align:#left
		dropdownlist ddl1 "" pos:[44,52] width:146 height:22 items:#("local", "grid", "world") selection:1 align:#left visible:false
		checkbox chkp "Layout plan" pos:[posX,posY+uiheight*2] height:16 checked:true align:#left tooltip:"On: use layout plan\nOff: Use elevation"
		checkbox chkd "Add dimension after" pos:[posX+100,posY+uiheight*2] width:166 height:16 checked:false align:#left tooltip:"Add dimension"
		button btn1 "Local" pos:[posX,posY+uiheight*3] width:90 height:30 align:#left tooltip:"Projection using #local"
		button btn3 "World" pos:[posX + 100,posY+uiheight*3] width:90 height:30 align:#left tooltip:"Projection using #world"
		button btn2 "Save DWG" pos:[posX + 200,posY+uiheight*3] width:90 height:30 align:#left tooltip:"Export the selected 2D line to CAD"
		fn viewgeofilttt o =
		(
			local xl_proxyxrefid = #("#(1828010099, 536368280)","#(-1834306676, 0)")
			(
				(superclassof o == geometryclass and classof o != linkcomposite and not o.istarget)or
				(
					finditem xl_proxyxrefid(o.classid as string) == 0 \
					and superclassof o == shape and classof o != polymorphicgeomshape and classof o != linkcompositeshape and o.baseobject.renderable
				)
			)
		)
		fn collapse_union myobj =
		(
			kh_sel = for i in myobj where viewgeofilttt i collect i
			if kh_sel.count > 0 do
			(
				converttomesh kh_sel
				kl_comgjkd1 = kh_sel.count
				for gg = 2 to kl_comgjkd1 do
				(
					meshop.attach kh_sel[1] kh_sel[gg] attachmat:#idtomat condensemat:true deletesourcenode:true
				)
				converttopoly kh_sel[1]
				centerpivot kh_sel[1]
				return kh_sel[1]
			)
		)
		fn setshapedir s rotation =
		(
			local rotvalinv = inverse(rotation as quat)
			animate off in coordsys local s.rotation *= rotvalinv
			s.objectoffsetrot *= rotvalinv
			s.objectoffsetpos *= rotvalinv
		)
		fn createspl insel inselarry =
		(
			max create mode
			local temps = splineshape pos:insel.pos wirecolor:insel.wirecolor name:(uniquename (insel.name + "_createspl")) transform:insel.transform
			for i in inselarry do
			(
				addnewspline temps
				for k = 1 to (numknots insel i) do
				(
					addknot temps i (getknottype insel i k) #curve (getknotpoint insel i k) (getinvec insel i k) (getoutvec insel i k)
				)
				if (isclosed insel i) do (close temps i)
			)
			try (updateshape temps)catch()
			centerpivot temps
			weldspline temps 1
			return temps
		)
		fn optimizeshape cshape m =
		(
			local newcshape = #()
			for cs in cshape do
			(
				try
				(
					if isvalidnode cs and (numsplines cs) > 0 then
					(
						local splarr = for n = 1 to (numsplines cs) collect n
						local tempspl = createspl cs splarr
						append newcshape tempspl
					)
					else(append newcshape undefined)
				)
				catch(append newcshape undefined)
			)
			return newcshape
		)
		fn setshapetoplane cshape m mode:ddl1.selection =
		(
			local xlen = m.center.x - m.min.x
			local ylen = m.center.y - m.min.y
			local zlen = m.center.z - m.min.z
			if isvalidnode cshape[1] do
			(
				case mode of
				(
					1:
					(
						in coordsys local move cshape[1] [xlen * 4,ylen * 2,-zlen]
						in coordsys local rotate cshape[1] 90 y_axis
						in coordsys local rotate cshape[1] -90 x_axis
					)
					2:
					(
						in coordsys grid move cshape[1] [xlen * 4,ylen * 2,zlen]
						in coordsys grid rotate cshape[1] 90 y_axis
						in coordsys grid rotate cshape[1] 90 z_axis
					)
					3:
					(
						in coordsys world move cshape[1] [xlen * 4,ylen * 2,-zlen]
						in coordsys world rotate cshape[1] 90 y_axis
						in coordsys world rotate cshape[1] 90 z_axis
					)
				)
				setshapedir cshape[1] (eulerangles 0 -90 0)
			)
			if isvalidnode cshape[2] do
			(
				case mode of
				(
					1:
					(
						in coordsys local move cshape[2] [xlen * 2,ylen * 2,-zlen]
						in coordsys local rotate cshape[2] -90 x_axis
					)
					2:
					(
						in coordsys grid move cshape[2] [xlen * 2,ylen * 2,zlen]
						in coordsys grid rotate cshape[2] -90 x_axis
					)
					3:
					(
						in coordsys world move cshape[2] [xlen * 2,ylen * 2,-zlen]
						in coordsys world rotate cshape[2] -90 x_axis
					)
				)
				setshapedir cshape[2] (eulerangles 90 0 0)
			)
			if isvalidnode cshape[3] do
			(
				case mode of
				(
					1:
					(
						in coordsys local move cshape[3] [xlen * 2,0,-zlen]
					)
					2:
					(
						in coordsys grid move cshape[3] [xlen * 2,0,zlen]
					)
					3:
					(
						in coordsys world move cshape[3] [xlen * 2,0,-zlen]
					)
				)
			)
			if isvalidnode cshape[4] do
			(
				case mode of
				(
					1:
					(
						in coordsys local move cshape[4] [xlen * 4,ylen * 2,-zlen]
						in coordsys local rotate cshape[4] 90 y_axis
						in coordsys local rotate cshape[4] -90 x_axis
					)
					2:
					(
						in coordsys grid move cshape[4] [xlen * 4,ylen * 2,zlen]
						in coordsys grid rotate cshape[4] 90 y_axis
						in coordsys grid rotate cshape[4] 90 z_axis
					)
					3:
					(
						in coordsys world move cshape[4] [xlen * 4,ylen * 2,-zlen]
						in coordsys world rotate cshape[4] 90 y_axis
						in coordsys world rotate cshape[4] 90 z_axis
					)
				)
				setshapedir cshape[4] (eulerangles 0 -90 0)
			)
			if isvalidnode cshape[5] do
			(
				case mode of
				(
					1:
					(
						in coordsys local move cshape[5] [xlen * 2,ylen * 2,-zlen]
						in coordsys local rotate cshape[5] -90 x_axis
					)
					2:
					(
						in coordsys grid move cshape[5] [xlen * 2,ylen * 2,zlen]
						in coordsys grid rotate cshape[5] -90 x_axis
					)
					3:
					(
						in coordsys world move cshape[5] [xlen * 2,ylen * 2,-zlen]
						in coordsys world rotate cshape[5] -90 x_axis
					)
				)
				setshapedir cshape[5] (eulerangles 90 0 0)
			)
			if isvalidnode cshape[6] do
			(
				case mode of
				(
					1:
					(
						in coordsys local move cshape[6] [xlen * 2,0,-zlen]
					)
					2:
					(
						in coordsys grid move cshape[6] [xlen * 2,0,zlen]
					)
					3:
					(
						in coordsys world move cshape[6] [xlen * 2,0,-zlen]
					)
				)
			)
		)
		fn setshapelocation cshape m mode:ddl1.selection =
		(
			local xlen = m.center.x - m.min.x
			local ylen = m.center.y - m.min.y
			local zlen = m.center.z - m.min.z
			if isvalidnode cshape[1] do
			(
				case mode of
				(
					1:(in coordsys local move cshape[1] [-xlen * 1.5,0,0])
					2:(in coordsys grid move cshape[1] [-xlen * 1.5,0,0])
					3:(in coordsys world move cshape[1] [-xlen * 1.5,0,0])
				)
				setshapedir cshape[1] (eulerangles 0 -90 0)
			)
			if isvalidnode cshape[2] do
			(
				case mode of
				(
					1:(in coordsys local move cshape[2] [0,-ylen * 1.5,0])
					2:(in coordsys grid move cshape[2] [0,-ylen * 1,0])
					3:(in coordsys world move cshape[2] [0,-ylen * 1.5,0])
				)
				setshapedir cshape[2] (eulerangles 90 0 0)
			)
			if isvalidnode cshape[3] do
			(
				case mode of
				(
					1:(in coordsys local move cshape[3] [0,0,-zlen])
					2:(in coordsys grid move cshape[3] [0,0,-zlen])
					3:(in coordsys world move cshape[3] [0,0,-zlen])
				)
			)
			if isvalidnode cshape[4] do
			(
				case mode of
				(
					1:(in coordsys local move cshape[4] [xlen * 1.5,0,0])
					2:(in coordsys grid move cshape[4] [xlen * 1.5,0,0])
					3:(in coordsys world move cshape[4] [xlen * 1.5,0,0])
				)
				setshapedir cshape[4] (eulerangles 0 -270 0)
			)
			if isvalidnode cshape[5] do
			(
				case mode of
				(
					1:(in coordsys local move cshape[5] [0,ylen * 1,0])
					2:(in coordsys grid move cshape[5] [0,ylen * 1.5,0])
					3:(in coordsys world move cshape[5] [0,ylen * 1.5,0])
				)
				setshapedir cshape[5] (eulerangles 270 0 0)
			)
			if isvalidnode cshape[6] do
			(
				case mode of
				(
					1:(in coordsys local move cshape[6] [0,0,zlen])
					2:(in coordsys grid move cshape[6] [0,0,zlen])
					3:(in coordsys world move cshape[6] [0,0,zlen])
				)
			)
		)
		fn sixviewgetshape m mode:1 view:"x" =
		(
			local obj = copy m name:("geometrytoshape_" + view)
			local zhou = #x
			local zhoua = [1,1,1]
			case mode of
			(
				1:
				(
					case view of
					(
						"x":
						(
							max vpt left
							zhou = #x
							zhoua = [0,1,1]
						)
						"xa":
						(
							max vpt right
							zhou = #x
							zhoua = [0,1,1]
						)
						"y":
						(
							max vpt front
							zhou = #y
							zhoua = [1,0,1]
						)
						"ya":
						(
							max vpt back
							zhou = #y
							zhoua = [1,0,1]
						)
						"z":
						(
							max vpt top
							zhou = #z
							zhoua = [1,1,0]
						)
						"za":
						(
							max vpt bottom
							zhou = #z
							zhoua = [1,1,0]
						)
					)
					worldalignobject obj
					alignpivot obj
				)
				2:
				(
					case view of
					(
						"x":
						(
							actionMan.executeaction 0 "40319"
							zhoua = [1,1,0]
						)
						"xa":
						(
							actionMan.executeaction 0 "40320"
							zhoua = [1,1,0]
						)
						"y":
						(
							actionMan.executeaction 0 "40316"
							zhoua = [1,1,0]
						)
						"ya":
						(
							actionMan.executeaction 0 "40317"
							zhoua = [1,1,0]
						)
						"z":
						(
							actionMan.executeaction 0 "40315"
							zhoua = [1,1,0]
						)
						"za":
						(
							actionMan.executeaction 0 "40318"
							zhoua = [1,1,0]
						)
					)
				)
				3:
				(
					case view of
					(
						"x":
						(
							max vpt left
							zhoua = [0,1,1]
						)
						"xa":
						(
							max vpt right
							zhoua = [0,1,1]
						)
						"y":
						(
							max vpt front
							zhoua = [1,0,1]
						)
						"ya":
						(
							max vpt back
							zhoua = [1,0,1]
						)
						"z":
						(
							max vpt top
							zhoua = [1,1,0]
						)
						"za":
						(
							max vpt bottom
							zhoua = [1,1,0]
						)
					)
				)
			)
			select obj
			setselectionlevel obj #edge
			obj.editablepoly.setselection #edge #{1..(obj.edges.count)}
			if radtype.state == 3 then
			(
				polytoolsselect.perspective 90 true
			)
			else
			(
				polytoolsselect.perspective 90 false
			)
			setselectionlevel obj #object
			case mode of
			(
				1:(obj.editablepoly.makeplanarin zhou)
				2:(in coordsys grid scale obj zhoua)
				3:(in coordsys world scale obj zhoua)
			)
			local seledg = #{}
			local verp = #()
			if radtype.state == 2 do
			(
				local seg = (obj.editablepoly.getselection #edge) as array
				for g in seg do
				(
					local ver = (polyop.getvertsusingedge obj #{g})as array
					local p1 = polyop.getvert obj ver[1]
					local pointa = [(p1.x as integer),(p1.y as integer),(p1.z as integer)]
					local p2 = polyop.getvert obj ver[2]
					local pointb = [(p2.x as integer),(p2.y as integer),(p2.z as integer)]
					local fval = pointa * pointb + pointa + pointb
					if finditem verp fval == 0 do
					(
						append verp fval
						append seledg g
						---------------------------------------------------------------
						-- commented from original version
						-- always triggered when using optimization extract
						-- maybe because all vars now localized?
						---------------------------------------------------------------
						-- break()
						---------------------------------------------------------------
					)
				)
				obj.editablepoly.setselection #edge seledg
			)
			obj.editablepoly.createshape ("geometrytoshape_" + view + "_shape") off obj
			return (execute ("$geometrytoshape_" + view + "_shape"))
		)
		fn run =
		(
			with undo off
			(
				disablesceneredraw()
				local gv = viewport.gettype()
				max vpt persp user
				local tm = viewport.gettm()
				local fov = viewport.getfov()
				local selobj = selection as array
				try
				(
					thawselection()
					subobjectlevel = 0
					if radtype.state == 3 then (max modify mode)else (max create mode)
					local myobj = #()
					for s in selection where ((superclassof s == geometryclass )and(canconvertto s mesh)) do
					(
						local cs = copy s name:(uniquename "geometrytoshape") wirecolor:s.wirecolor
						resettransform cs
						centerpivot cs
						converttopoly cs
						append myobj cs
					)
					if myobj.count == 0 do
					(
						enablesceneredraw()
						return messagebox "Please select an object: geometry" beep:false
					)
					if ddl1.selection == 2 and activeGrid == undefined do
					(
						delete $geometrytoshape*
						enablesceneredraw()
						return messagebox "Active grid not found: please activate grid" beep:false
					)
					if radtype.state != 3 do (suspendediting())
					local m = collapse_union myobj
					local cshape = #(undefined,undefined,undefined,undefined,undefined,undefined)
					local myrotation = m.rotation
					local mysize = ((distance m.max m.min) * 0.0499916) as integer
					local myshapes = #()
					if chkx.state do
					(
						cshape[1] = sixviewgetshape m mode:ddl1.selection view:"x"
					)
					if chky.state do
					(
						cshape[2] = sixviewgetshape m mode:ddl1.selection view:"y"
					)
					if chkz.state do
					(
						cshape[3] = sixviewgetshape m mode:ddl1.selection view:"z"
					)
					if chkxa.state do
					(
						cshape[4] = sixviewgetshape m mode:ddl1.selection view:"xa"
					)
					if chkya.state do
					(
						cshape[5] = sixviewgetshape m mode:ddl1.selection view:"ya"
					)
					if chkza.state do
					(
						cshape[6] = sixviewgetshape m mode:ddl1.selection view:"za"
					)
					for c = 1 to cshape.count do if cshape[c] != undefined do
					(
						if ddl1.selection == 1 then
						(
							rotate cshape[c] (angleaxis ((quattoeuler2 (inverse myrotation)).x) [1,0,0])
							rotate cshape[c] (angleaxis ((quattoeuler2 (inverse myrotation)).y) [0,1,0])
							rotate cshape[c] (angleaxis ((quattoeuler2 (inverse myrotation)).z) [0,0,1])
						)
						else
						(
							resettransform cshape[c]
						)
						if radtype.state == 3 then
						(
							if c < 4 then (cshape[c].wirecolor = black) else (cshape[c].wirecolor = color 128 128 128)
						)
						else
						(
							cshape[c].wirecolor = m.wirecolor
						)
						centerobject cshape[c]
						in coordsys local cshape[c].pos = m.center
					)
					if chkp.state then (setshapetoplane cshape m) else (setshapelocation cshape m)
					if radtype.state == 1 or radtype.state == 3 do
					(
						for c in cshape do if c != undefined do
						(
							c.name = (uniquename "toshape_")
							appendifunique myshapes c
						)
					)
					if radtype.state == 2 do
					(
						local newcshape = optimizeshape cshape m
						for c in newcshape do if c != undefined do
						(
							c.name = (uniquename "toshape_")
							appendifunique myshapes c
						)
					)
					if radtype.state != 3 do (resumeediting())
					if chkd.state do
					(
						ab_dimensionmark.startautomark myshapes mysize mysize false facy:1 isinvert:false
					)
				)
				catch
				(
					enablesceneredraw()
					resumeediting()
					delete $geometrytoshape*
				)
				delete $geometrytoshape*
				select selobj
				viewport.settype gv
				if gv != #view_grid and gv != #view_top and gv != #view_bottom and gv != #view_front and gv != #view_back and gv != #view_left and gv != #view_right do
				(
					max vpt persp user
					viewport.settm tm
					viewport.setfov fov
				)
				gc light:true
				enablesceneredraw()
				completeredraw()
			)
		)
		on btn1 pressed do
		(
			ddl1.selection = 1
			run()
		)
		on btn3 pressed do
		(
			ddl1.selection = 3
			run()
		)
		on btn2 pressed do
		(
			if selection.count > 0 then
			(
				getms = getsavefilename caption:"Export 2D lines to CAD" types:"save dwg(*.dwg)|(*.dwg)|"
				if getms != undefined then
				(
					theclasses = exporterplugin.classes
					exportfile (getms + ".dwg") selectedonly:true using:theclasses[3]
				)
			)
			else messagebox "Please select the 2D lines you want to export" beep:false
		)
		on radtype changed state do
		(
			if state == 2 do
			(
				qq = querybox "The normal mode has removed most of the overlap\nThe optimization mode traverses whether each edge overlaps\nIf the number of model faces exceeds 50000, it will wait for a few minutes or even get stuck"
				if not qq do radtype.state = 1
			)
		)
		on geometrytoshape open do (
			posX = if (posX=getINISetting iniFile "geometrytoshape" "posX")=="" then 100 else (posX as integer)
			posY = if (posY=getINISetting iniFile "geometrytoshape" "posY")=="" then 100 else (posY as integer)
			setDialogPos geometrytoshape [posX,posY]
		)
		on geometrytoshape close do (
			local pos = GetDialogPos geometrytoshape
			setINISetting iniFile "geometrytoshape" "posX" (pos[1] as string)
			setINISetting iniFile "geometrytoshape" "posY" (pos[2] as string)
		)
	)
	createdialog geometrytoshape
)